/*
 *  Copyright (c) 2000 Matthias Hlzer-Klpfel <hoelzer@kde.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 */

#ifndef __swallow_h__
#define __swallow_h__


#include <qxembed.h>


#include <kpanelapplet.h>


class KWinModule;
class KProcess;


class SwallowApplet : public KPanelApplet
{
  Q_OBJECT
	
public:

  SwallowApplet(QWidget* parent = 0, const char* name = 0);
  ~SwallowApplet();

  int widthForHeight(int height);
  int heightForWidth(int width);


protected slots:

  void windowAdd(WId win);
  void processExited(KProcess *proc);


protected:

  void resizeEvent(QResizeEvent*);

  QXEmbed *embed;

  KWinModule *winModule;
  KProcess   *process;

};

#endif // __swallow_h__
